#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/* 8000Hz */
#define BASE_STATES	1022	/* ̔g̃Xe[g */
#define OVERHEAD_STATES	192	/* I[o[wbhXe[g */
#define BASE_TIME	8000	/* ̏o̓JEg */

#if 0
/* 11025Hz */
#define BASE_STATES	746	/* ̔g̃Xe[g */
#define OVERHEAD_STATES	192	/* I[o[wbhXe[g */
#define BASE_TIME	11025	/* ̏o̓JEg */
#endif

int main(int argc, char *argv[])
{
	const char *name[] = {
		"2C ", "2C#", "2D ", "2D#", "2E ", "2F ", "2F#", "2G ", "2G#", "2A ", "2A#", "2B ",
		"3C ", "3C#", "3D ", "3D#", "3E ", "3F ", "3F#", "3G ", "3G#", "3A ", "3A#", "3B ",
		"4C ", "4C#", "4D ", "4D#", "4E ", "4F ", "4F#", "4G ", "4G#", "4A ", "4A#", "4B "
	};
	double f[36];
	double a = pow(1.97, 1.0 / 12.0); /* Ȃ2.0ł̓_Ȃ̂낤??? */
	int i, note, s = 0, states[36], states_real[36], jump[36], j = 0, *p_jump = jump, op[512], *p_op = op;
	unsigned int base_time[36];
	struct {
		char *name;
		int states;
		int size;
	} op_table[] = {
		{ "call delay23", 27 + 4 * 23, 3 },
		{ "call delay22", 27 + 4 * 22, 3 },
		{ "call delay21", 27 + 4 * 21, 3 },
		{ "call delay20", 27 + 4 * 20, 3 },
		{ "call delay19", 27 + 4 * 19, 3 },
		{ "call delay18", 27 + 4 * 18, 3 },
		{ "call delay17", 27 + 4 * 17, 3 },
		{ "call delay16", 27 + 4 * 16, 3 },
		{ "call delay15", 27 + 4 * 15, 3 },
		{ "call delay14", 27 + 4 * 14, 3 },
		{ "call delay13", 27 + 4 * 13, 3 },
		{ "call delay12", 27 + 4 * 12, 3 },
		{ "call delay11", 27 + 4 * 11, 3 },
		{ "call delay10", 27 + 4 * 10, 3 },
		{ "call delay9", 27 + 4 * 9, 3 },
		{ "call delay8", 27 + 4 * 8, 3 },
		{ "call delay7", 27 + 4 * 7, 3 },
		{ "call delay6", 27 + 4 * 6, 3 },
		{ "call delay5", 27 + 4 * 5, 3 },
		{ "call delay4", 27 + 4 * 4, 3 },
		{ "call delay3", 27 + 4 * 3, 3 },
		{ "call delay2", 27 + 4 * 2, 3 },
		{ "call delay1", 27 + 4 * 1, 3 },
		{ "call delay0", 27 + 4 * 0, 3 },
		{ "ld A, (HL)", 7, 1 },
		{ "nop", 4, 1 }
	};

	memset(op, 0, sizeof(op));
	memset(states_real, 0, sizeof(states_real));

	/* g߂ */
	f[12] = 261.6255653005986;
	for(note = 11; note >= 0; note--)
		f[note] = f[note + 1] / a;
	for(note = 13; note < sizeof(f) / sizeof(f[0]); note++)
		f[note] = f[note - 1] * a;

	/* g(I[o[wbh)߂ */
	for(note = 0; note < sizeof(f) / sizeof(f[0]); note++)
		states[note] = (int )((BASE_STATES * f[12] + f[note] / 2.0) / f[note]) - OVERHEAD_STATES;

	/* _~[R[h쐬 */
	for(note = sizeof(f) / sizeof(f[0]) - 1; note >= 0; note--) {
		if(note == sizeof(f) / sizeof(f[0]) - 1) {
			s += (states[note] - 0);
			states_real[note] = 0;
		} else {
			s += (states[note] - states[note + 1]);
			states_real[note] = states_real[note + 1];
		}

		for(;;) {
			printf("note=%d, %d, %d (%d)\n", note, s, states_real[note], states[note]);
			for(i = 0; i < sizeof(op_table) / sizeof(op_table[0]); i++) {
				if(s >= op_table[i].states - 2) {
					s -= op_table[i].states;
					j += op_table[i].size;
					states_real[note] += op_table[i].states;
					*p_op++ = i;
					break;
				}
			}
			if(i == sizeof(op_table) / sizeof(op_table[0]))
				break;
		}
		printf("\n");
		*p_jump++ = j;
	}

	/* Ԃ߂ */
	for(note = 0; note < sizeof(f) / sizeof(f[0]); note++)
		base_time[note] = (long long )BASE_TIME * 60 * 4 * (f[note] / f[12]);

	/* g\(AZu)o͂ */
	for(i = sizeof(jump) / sizeof(jump[0]) - 1; i >= 0; i--)
		printf("\t.db %d\t; %s\n", jump[i], name[sizeof(jump) / sizeof(jump[0]) - i - 1]);
	printf("\t.db 0\t; R\n");
	printf("\n");

	/* (AZu)o͂ */
	for(note = 0; note < sizeof(f) / sizeof(f[0]); note++)
		printf("\t.db 0x%02x, 0x%02x, 0x%02x\t; %s %d\n", base_time[note] & 0xff, (base_time[note] >> 8) & 0xff, (base_time[note] >> 16) & 0xff, name[note], base_time[note]);
	printf("\n");

	/* _~[R[ho͂ */
	for(i = (int )(p_op - op) - 1; i >= 0; i--)
		printf("\t%s\t; _~[\n", op_table[op[i]].name);
	printf("\n");

	/* g\(C)o͂ */
	printf("const int wavelength[] = {\n");
	for(i = sizeof(jump) / sizeof(jump[0]) - 1; i >= 0; i--)
		printf("\t%d,\t/* %s */\n", jump[i], name[sizeof(jump) / sizeof(jump[0]) - i - 1]);
	printf("};\n\n");

	/* (C)o͂ */
	printf("const int base_time[] = {\n");
	for(note = 0; note < sizeof(f) / sizeof(f[0]); note++) {
		printf("\t%d,\t/* %s */\n", base_time[note], name[note]);
	}
	printf("};\n");

	return 0;
}

/* eof */
