#include <stdio.h>
#include <stdlib.h>
#include "onebit.h"

#define OUT_RATE	8000

int main(int argc, char *argv[])
{
	int i, j, size, rate, pos, v = 0, max, min, c = 0;
	unsigned char *in, *out, *p, *q;

	if((in = readWave(&size, &rate, argv[1])) == NULL)
		return 1;

	p = out = malloc(size);

	for(i = 0; i < (unsigned int )size * OUT_RATE; i += rate) {
		if(i < 0)
			break;
		pos = i / OUT_RATE;

		/* ϒl𓾂 */
		/*
		v = 0;
		for(j = pos; j < pos + rate / OUT_RATE; j++)
			v += in[j];
		v = v / (rate / OUT_RATE);
		*/

		/* őlƍŏl𓾂 */
		max = 0;
		min = 0xff;
		for(j = pos; j < pos + rate / OUT_RATE && j < size; j++) {
			if(max < in[j])
				max = in[j];
			if(min > in[j])
				min = in[j];
		}
		if(max - 0x80 == 0x80 - min && max != min) {
			if(v == 0)
				v = 0xff;
			else
				v = 0;
		} if(max - 0x80 > 0x80 - min)
			v = 0xff;
		else
			v = 0;

		if(v >= 0x80) {
			if(v - 0x80 > 0)
				*p++ = 0xff;
			else
				*p++ = 0;
		} else {
			if(v < 0)
				*p++ = 0xff;
			else
				*p++ = 0;
		}
	}

	size = (int )(p - out);

	if(writeWave("out.wav", out, size, OUT_RATE) < 0)
		return 1;

	printf("wave_%s::\n", argv[2]);
	printf("\t.dw %d\n", size);
	for(q = out; q < out + size; q += 64) {
		printf("\t.db ");
	
		for(p = q; p < q + 64 && p < out + size; p += 8) {
			if(p != q)
				printf(", ");
			printf("0x%02x",
			(*(p + 7) > 0x80 ? 0x80: 0) |
			(*(p + 0) > 0x80 ? 0x40: 0) |
			(*(p + 1) > 0x80 ? 0x20: 0) |
			(*(p + 2) > 0x80 ? 0x10: 0) |
			(*(p + 3) > 0x80 ? 0x08: 0) |
			(*(p + 4) > 0x80 ? 0x04: 0) |
			(*(p + 5) > 0x80 ? 0x02: 0) |
			(*(p + 6) > 0x80 ? 0x01: 0)
			);
		}

		printf("\n");
	}
	
	free(in);
	free(out);
	return 0;
}

/* eof */
